package org.bdware.sc.registry;

import com.alibaba.datax.transport.transformer.maskingMethods.differentialPrivacy.EpsilonDifferentialPrivacyImpl;
import com.alibaba.datax.transport.transformer.maskingMethods.irreversibleInterference.MD5EncryptionImpl;

public class RuleHelper {
    public static String md5(Object obj) {
        try {
            MD5EncryptionImpl masker = new MD5EncryptionImpl();
            return masker.execute(obj.toString());
        } catch (Exception e) {
            return "*****" + e.getMessage() + "****";
        }
    }

    public static Object edp(Object obj, double epsilon) {
        try {
            EpsilonDifferentialPrivacyImpl masker = new EpsilonDifferentialPrivacyImpl();
            double result = 0;
            result = masker.maskOne(Double.valueOf(obj.toString()), epsilon);
            return result;
        } catch (Exception e) {
            e.printStackTrace();
            return "***" + e.getMessage() + "***";
        }
    }
}
