
import com.google.gson.JsonArray;
import com.google.gson.JsonObject;
import wrp.jdk.nashorn.api.scripting.NashornScriptEngine;
import wrp.jdk.nashorn.api.scripting.ScriptUtils;
import org.apache.lucene.queryparser.classic.ParseException;
import org.bdware.sc.boundry.JavaScriptEntry;
import org.bdware.sc.engine.JSONTool;
import org.junit.Test;
import org.bdware.datanet.searchengine.SearchEngine;
import wrp.jdk.nashorn.api.scripting.NashornScriptEngine;
import wrp.jdk.nashorn.api.scripting.NashornScriptEngineFactory;
import wrp.jdk.nashorn.api.scripting.ScriptObjectMirror;
import wrp.jdk.nashorn.internal.objects.Global;
import wrp.jdk.nashorn.internal.runtime.*;

import java.io.IOException;
import java.util.ArrayList;

public class searchEnginetest {
    public static String dbname="MetaIndex01";
    @Test
    public void test2() throws IOException, ParseException{
        System.out.println("hello");
        //1642696178922
        System.out.println(System.currentTimeMillis());
    }

    @Test
    public void addDo()  {
        NashornScriptEngineFactory factory = new NashornScriptEngineFactory();
        NashornScriptEngine engine = (NashornScriptEngine)factory.getScriptEngine("--language=es6");
        SearchEngine se=SearchEngine.createObj(dbname);
        //SearchEngine se=new SearchEngine();
        try{
            engine.eval("var r1 = {\"url\":\"39.106.6.6:3306\",\"user\":\"loushuai\",\"password\":\"loushuai\",\"dbname\":\"newele\",\"tablename\":\"data\",\"createTime\":\"1641363811328\",\"owner\":\"zzz\",\"description\":\"这是一段说明\",\"schema\":\"{}\",\"prefix\":\"aibd.govdata.tj\",\"type\":\"SQL\",\"doId\":\"aibd.govdata.tj/DBRepo/do.newele.data\"};");
            se.testScriptObjectMirror((ScriptObjectMirror) engine.eval("r1"));
            System.out.println(se.update((ScriptObjectMirror) engine.eval("r1")));
            //System.out.println(se.search("info","产品"));

        }catch(Exception e){
            e.printStackTrace();
        }

    }

    @Test
    public void addDo2()  {
        NashornScriptEngineFactory factory = new NashornScriptEngineFactory();
        NashornScriptEngine engine = (NashornScriptEngine)factory.getScriptEngine("--language=es6");
        SearchEngine se=SearchEngine.createObj(dbname);
        //SearchEngine se=new SearchEngine();
        try{
            engine.eval("var r1 = {doId:\"AIBD/doip.Repo10101\", type:\"readme\", createTime:\"1642696178922\",info:\"我们这款产品底层逻辑是打通信息屏障，创建行业生态。顶层设计是聚焦用户感和赛道，通过差异化和颗粒度达到引爆点。交付价值是在垂直领域采用复用大法达成持久收益。抽离透传归因分析作为抓手为产品赋能，体验度量作为闭环的评判标准。亮点是载体，优势是链路。思考整个生命周期，完善逻辑，考虑资源倾斜。方法论是组合拳达到平台化标准。\"};");
            se.testScriptObjectMirror((ScriptObjectMirror) engine.eval("r1"));
            System.out.println(se.update((ScriptObjectMirror) engine.eval("r1")));

            engine.eval("var r2 = {doId:\"AIBD/doip.Repo10102\", type:\"readme\", createTime:\"1842696178922\",info:\"我们这款产品底层逻辑是打通信息屏障，创建行业生态。顶层设计是聚焦用户感和赛道，通过差异化和颗粒度达到引爆点。交付价值是在垂直领域采用复用大法达成持久收益。抽离透传归因分析作为抓手为产品赋能，体验度量作为闭环的评判标准。亮点是载体，优势是链路。思考整个生命周期，完善逻辑，考虑资源倾斜。方法论是组合拳达到平台化标准。\"};");
            se.testScriptObjectMirror((ScriptObjectMirror) engine.eval("r2"));
            System.out.println(se.update((ScriptObjectMirror) engine.eval("r2")));
            //System.out.println(se.search("info","产品"));
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    @Test
    public void addDoList()
    {
        NashornScriptEngineFactory factory = new NashornScriptEngineFactory();
        NashornScriptEngine engine = (NashornScriptEngine)factory.getScriptEngine("--language=es6");
        SearchEngine se=SearchEngine.createObj(dbname);
        try{
            engine.eval("var j1 = [{doId:\"AIBD/doip.Repo10101\", type:\"readme\", createTime:\"1642696178922\",info:\"我们这款产品底层逻辑是打通信息屏障……\"}," +
                                        "{doId:\"AIBD/doip.Repo10102\", type:\"readme\", createTime:\"1642696198922\",info:\"你们这款产品底层逻辑是打通信息屏障……\"}];");
            se.update((ScriptObjectMirror) engine.eval("j1"));
            System.out.println(se.search("info","产品"));
        }catch(Exception e){
            e.printStackTrace();
        }

    }
    @Test
    public void searchRepoTest() throws IOException, ParseException {
        NashornScriptEngineFactory factory = new NashornScriptEngineFactory();
        NashornScriptEngine engine = (NashornScriptEngine)factory.getScriptEngine("--language=es6");
        SearchEngine se=SearchEngine.createObj(dbname);
        try{
            engine.eval("var arg ={type:\"doId\",keyword:\"AIBD/doip.Repo\"};");
            System.out.println(se.search((ScriptObjectMirror) engine.eval("arg")));
            engine.eval("var arg1 ={type:\"owner\",keyword:\"zzz\"};");
            System.out.println(se.search((ScriptObjectMirror) engine.eval("arg1")));
            //System.out.println(se.search("info","产品",5,0));
        }catch(Exception e){
            e.printStackTrace();
        }


    }
    @Test
    public void searchByRangeTest() throws IOException, ParseException {
        NashornScriptEngineFactory factory = new NashornScriptEngineFactory();
        NashornScriptEngine engine = (NashornScriptEngine)factory.getScriptEngine("--language=es6");
        SearchEngine se=SearchEngine.createObj(dbname);
        try{
            engine.eval("var arg ={type:\"createTime\",from:\"1642696178922\",to:\"1942696178922\"};");
            //engine.eval("var arg ={type:\"createTime\",keyword:\"createTime\",from:\"1642696178922\",to:\"1642696178922\"};");
            System.out.println(se.searchByRange ((ScriptObjectMirror) engine.eval("arg")));
        }catch(Exception e){
            e.printStackTrace();
        }

    }

    //{"params":[{"type":"doid","ketword":"DBRepo"},{"type":"name","ketword":"xxx"}],"count":10,"offset":0}

    @Test
    public void searchByMultiTagTest() {
        NashornScriptEngineFactory factory = new NashornScriptEngineFactory();
        NashornScriptEngine engine = (NashornScriptEngine)factory.getScriptEngine("--language=es6");
        SearchEngine se=SearchEngine.createObj(dbname);
        try{
//            engine.eval("var r1 = {doId:\"repo1\", type:\"readme\", createTime:\"1642696178922\",info:\"我们这款产品底层逻辑是打通信息屏障，创建行业生态。\"};");
//            System.out.println(se.update((ScriptObjectMirror) engine.eval("r1")));
//
//            engine.eval("var r2 = {doId:\"repo2\", type:\"sql\", createTime:\"1642696178922\",info:\"我们这款产品底层逻辑是打通信息屏障，创建行业生态。\"};");
//            System.out.println(se.update((ScriptObjectMirror) engine.eval("r2")));

            engine.eval("var arg2 ={type:\"info\",keyword:\"我们\",count:10,offset:0};");
            System.out.println(se.search ((ScriptObjectMirror) engine.eval("arg2")));


            engine.eval("var arg1 ={params:[{type:\"doId\",keyword:\"AIBDdoip.Repo1001\"}],count:10,offset:0};");
            System.out.println(se.searchByMultiTag ((ScriptObjectMirror) engine.eval("arg1")));

            engine.eval("var arg ={params:[{type:\"info\",keyword:\"我们\"},{type:\"doId\",keyword:\"repo\"}],count:10,offset:0};");
            System.out.println(se.searchByMultiTag ((ScriptObjectMirror) engine.eval("arg")));

            engine.eval("var arg ={\n" +
                    "      params: [{ type: 'doId', keyword: 'd' }],\n" +
                    "      count: 100,\n" +
                    "      offset: 0,\n" +
                    "    };");
            System.out.println(se.searchByMultiTag ((ScriptObjectMirror) engine.eval("arg")));



        }catch(Exception e){
            e.printStackTrace();
        }

    }

    @Test
    public void deleteTest(){
        NashornScriptEngineFactory factory = new NashornScriptEngineFactory();
        NashornScriptEngine engine = (NashornScriptEngine)factory.getScriptEngine("--language=es6");
        SearchEngine se=SearchEngine.createObj(dbname);
        try{

            engine.eval("var r1 = {doId:\"AIBD/doip.Repo1001\"};");
            System.out.println(se.delete((ScriptObjectMirror)engine.eval("r1")));
            //se.delele((ScriptObjectMirror)engine.eval("doid"));
            System.out.println(se.search("info","产品"));
            System.out.println(se.search("doId","AIBD/doip.Repo1002"));
        }catch(Exception e){
            e.printStackTrace();
        }

    }
    @Test
    public void jsTest(){
        NashornScriptEngineFactory factory = new NashornScriptEngineFactory();
        NashornScriptEngine engine = (NashornScriptEngine)factory.getScriptEngine("--language=es6");
        SearchEngine se=SearchEngine.createObj(dbname);
        try{
            System.out.println(engine.eval("var car = {name:\"Fiat\", model:500, color:\"white\"};"));
            System.out.println(engine.eval("car").getClass());
            se.testScriptObjectMirror((ScriptObjectMirror) engine.eval("car"));
        }catch(Exception e){
            e.printStackTrace();
        }
    }

}
